
def is_divisible(a, b):
    return a % b == 0

# first version using nested conditionals
def is_leap_year_1(year):
    if is_divisible(year, 400):
        answer = True
    else:
        if is_divisible(year, 4):
            if is_divisible(year, 100):
                answer = False
            else:
                answer = True
        else:
            answer = False
    return answer

# second version using only one boolean expression
def is_leap_year_2(year):
    if is_divisible(year, 400) or (is_divisible(year, 4) and not is_divisible(year, 100)):
        answer = True
    else:
        answer = False

# third version directly returns the value of the boolean expression
def is_leap_year(year):
    return is_divisible(year, 400) or (is_divisible(year, 4) and not is_divisible(year, 100))
